*****************************************************************************
*
* RDATA.ASM
*
* ROXY Data Files (.SSM)
*
* The 1st  8 banks are 06h, 07h, 08h, 09h, 0Ah, 0Bh, 0Ch, 0Dh
*                       6    7    8    9   10   11   12	  13
*
* The last 5 banks are 3Ah, 3Bh, 3Ch, 3Dh, 3Eh
*                      58   59   60   61   62
*
*****************************************************************************

	.output	'dasm'

	.list	'rdata.lst'

	.asym


* - Tarzan Character Data [DATA]







	org	$068000

	.incl	'nrocdata\tzrun2.ssm'
	.incl	'nrocdata\tzshtstd.ssm'

	org	$078000

	.incl	'nrocdata\tzvineb1.ssm'
	.incl	'nrocdata\tzjmpfal.ssm'
	.incl	'nrocdata\door.pal'
	.incl	'nrocdata\waterpal.pal'

	org	$088000

	.incl	'nrocdata\tzswim.ssm'
	.incl	'nrocdata\tzswim1.ssm'
	.incl	'nrocdata\tzdart.ssm'

	org	$098000

	.incl	'nrocdata\tzclimb.ssm'
	.incl	'nrocdata\tzfloat.ssm'
	.incl	'nrocdata\tzpups1.pal'
	.incl	'nrocdata\tzpdrk04.pal'
	.incl	'nrocdata\tzpdrk03.pal'
	.incl	'nrocdata\tzpdrk02.pal'

	org	$0a8000

	.incl	'nrocdata\tzidle3.ssm'
	.incl	'nrocdata\tzpdrk01.pal'
	.incl	'nrocdata\tzpdrk00.pal'
	.incl	'nrocdata\tzhbar.pal'

	org	$0b8000

	.incl	'nrocdata\tzhitfal.ssm'
	.incl	'nrocdata\tzstab1.ssm'
	.incl	'nrocdata\dagger1.ssm'
	.incl	'nrocdata\tzhbai6.pal'
	.incl	'nrocdata\tzhbai5.pal'
	.incl	'nrocdata\tzhbai4.pal'

	org	$0c8000

	.incl	'nrocdata\tzidle1.ssm'
	.incl	'nrocdata\tzland.ssm'
	.incl	'nrocdata\tzhbai3.pal'
	.incl	'nrocdata\tzhbai2.pal'
	.incl	'nrocdata\tzhbai1.pal'
	.incl	'nrocdata\tzdampal.pal'
	.incl	'nrocdata\tzanpal.pal'

	org	$0d8000

	.incl	'nrocdata\tzwalk3.ssm'
	.incl	'nrocdata\tzwkaway.ssm'
	.incl	'nrocdata\hexnums.ssm'
	.incl	'nrocdata\hexnums.pal'
	.incl	'nrocdata\dagger1.pal'

	org	$3a8000

	.incl	'nrocdata\tzvineb2.ssm'
	.incl	'nrocdata\tzstdjmp.ssm'
	.incl	'nrocdata\tzlamp.ssm'
	.incl	'nrocdata\timesliv.ssm'

	org	$3b8000

	.incl	'nrocdata\tzjmprop.ssm'
	.incl	'nrocdata\tzjumpup.ssm'
	.incl	'nrocdata\tzpwrups.ssm'

	org	$3c8000

	.incl	'nrocdata\tzducks.ssm'
	.incl	'foes\foessm\flash.ssm'
	.incl	'nrocdata\tzidle2.ssm'
	.incl	'nrocdata\tzjmpstb.ssm'
	.incl	'nrocdata\tilebox.ssm'

	org	$3d8000

	.incl	'nrocdata\tzregen.ssm'
	.incl	'nrocdata\door.ssm'
	.incl	'nrocdata\watertop.ssm'
	.incl	'nrocdata\tzvnland.ssm'
	.incl	'nrocdata\tzroar.ssm'
	.incl	'nrocdata\tzvinfal.ssm'

	org	$3e8000

	.incl	'nrocdata\bossbar.ssm'
	.incl	'nrocdata\tzwkrnxu.ssm'
	.incl	'nrocdata\tzeol.ssm'
	.incl	'nrocdata\tzhbar.ssm'
	.incl	'nrocdata\tzrnwkxd.ssm'
	.incl	'nrocdata\flortrig.ssm'
	.incl	'nrocdata\tzpups1.ssm'
	.incl	'nrocdata\tzvine1a.ssm'
	.incl	'nrocdata\fonttst.ssm'
	.incl	'nrocdata\tzjpdnhd.ssm'
	.incl	'nrocdata\tzwait1.ssm'
	.incl	'nrocdata\tzpause.ssm'
	.incl	'nrocdata\tzdir.ssm'
	

	org	$3f8000

	.incl	'nrocdata\tzidle4.ssm'

