
;program specific data
_croamdat   
	.dw	$FFFE,$00,$FFFB,$00,$FFEF,$00,$FFBF,$00,$FEFF,$00,$FBFF,$00,$EFFF,$00,$BFFF,$00
	.dw	$FFFE,$02,$FFFB,$02,$FFEF,$02,$FFBF,$02,$FEFF,$02,$FBFF,$02,$EFFF,$02,$BFFF,$02
	.dw	$FFFE,$04,$FFFB,$04,$FFEF,$04,$FFBF,$04,$FEFF,$04,$FBFF,$04,$EFFF,$04,$BFFF,$04
	.dw	$FFFE,$06,$FFFB,$06,$FFEF,$06,$FFBF,$06,$FEFF,$06,$FBFF,$06,$EFFF,$06,$BFFF,$06
	.dw	$FFFE,$08,$FFFB,$08,$FFEF,$08,$FFBF,$08,$FEFF,$08,$FBFF,$08,$EFFF,$08,$BFFF,$08
	.dw	$FFFE,$0a,$FFFB,$0a,$FFEF,$0a,$FFBF,$0a,$FEFF,$0a,$FBFF,$0a,$EFFF,$0a,$BFFF,$0a
	.dw	$FFFE,$0c,$FFFB,$0c,$FFEF,$0c,$FFBF,$0c,$FEFF,$0c,$FBFF,$0c,$EFFF,$0c,$BFFF,$0c
	.dw	$FFFE,$0e,$FFFB,$0e,$FFEF,$0e,$FFBF,$0e,$FEFF,$0e,$FBFF,$0e,$EFFF,$0e,$BFFF,$0e
	.dw	$FFFE,$10,$FFFB,$10,$FFEF,$10,$FFBF,$10,$FEFF,$10,$FBFF,$10,$EFFF,$10,$BFFF,$10
	.dw	$FFFE,$12,$FFFB,$12,$FFEF,$12,$FFBF,$12,$FEFF,$12,$FBFF,$12,$EFFF,$12,$BFFF,$12
	.dw	$FFFE,$14,$FFFB,$14,$FFEF,$14,$FFBF,$14,$FEFF,$14,$FBFF,$14,$EFFF,$14,$BFFF,$14
	.dw	$FFFE,$16,$FFFB,$16,$FFEF,$16,$FFBF,$16,$FEFF,$16,$FBFF,$16,$EFFF,$16,$BFFF,$16
	.dw	$FFFE,$18,$FFFB,$18,$FFEF,$18,$FFBF,$18,$FEFF,$18,$FBFF,$18,$EFFF,$18,$BFFF,$18
	.dw	$FFFE,$1a,$FFFB,$1a,$FFEF,$1a,$FFBF,$1a,$FEFF,$1a,$FBFF,$1a,$EFFF,$1a,$BFFF,$1a
	.dw	$FFFE,$1c,$FFFB,$1c,$FFEF,$1c,$FFBF,$1c,$FEFF,$1c,$FBFF,$1c,$EFFF,$1c,$BFFF,$1c
	.dw	$FFFE,$1e,$FFFB,$1e,$FFEF,$1e,$FFBF,$1e,$FEFF,$1e,$FBFF,$1e,$EFFF,$1e,$BFFF,$1e

Createoam:
	LAI

	jsl	Clearoam

	phb

	ldx	#0

.croam0	cpx	z_attrcount     ;word partiton in ATTR
	bne	.croam1
	plb
	rtl

.croam1	lda	z_oamcount
	cmp	#$1fc
     	bcc	.okay
	plb
	rtl
.okay
	lda	ATTRX,x        ;16 bit X position in level
	sec
	sbc	z_levelx        ;X pos of screen left edge
	sta	z_sprix
	lda	ATTRY,x        ;16 bit Y position in level
	sec
	sbc	z_levely        ;Y pos of screen top edge
	sta	z_spriy
	lda	ATTRBANK,x
	SA
	pha
	LA
	plb
	lda	ATTRDREC,x     ;address of adresses for this drec
	sta	z_spridrec      ;store in zpage for indirect use
	ldy	#0
	lda	(z_spridrec),y   ;get count addr for current drec
	sta	z_dreccount
	iny
	iny
	lda	(z_spridrec),y   ;get offset addr for current drec
	sta	z_drecnum
	iny
	iny
	lda	(z_spridrec),y   ;get x offset addr for current drec
	sta	z_drecx
	iny
	iny
	lda	(z_spridrec),y   ;get y offset addr for current drec
	sta	z_drecy
	iny
	iny
	lda	(z_spridrec),y   ;get size addr
	sta	z_drecdim
	iny
	iny
	lda	(z_spridrec),y   ;get frame offset addr
	sta	z_drecframe
	stx	z_ztemp
	lda	ATTRFRAME,x    ;offset into frame table
	asl
	tay
	lda	ATTROFF,x      ;offset into sprite table and pal bits
	sta	v_spriteoff
	and	#$c000
	beq	.croamnorm    ;normal high speed no flip routine
	brl	.croamflip     ;flip routine
.croamnorm
	lda	(z_dreccount),y   ;number of objects in sprite
	sta	z_sprisize
	lda	(z_drecframe),y  ;frame # -- offset into other tables
	tay                   ;           the new indirect index
.croamloop
	lda	#1             ;amount of object that must show 
	sec
	sbc	(z_drecdim),y   ;dimension of object
	sta	v_spriedge      ;negative edge for display
	ldx	z_oamcount      ;index for next object in oam
	lda	(z_drecx),y     ;the x offset for this sub object
	clc
	adc	z_sprix         ;add to sprite x location
	sta	OBJECT,x       ;put x location in oam shadow
	cmp	#256           ; is it greater than right edge?
	bcc	.croamx        ;if not then branch to store it
	cmp	v_spriedge      ;is it less than negative edge?
	bcc	.croamnext     ;if not then do next object
	lda	#$FFFF         ;flag negative x
	bmi	.croamx2
.croamx     
	lda	#0             ;flag positive x
.croamx2
	sta	z_temp0         ;store flag
	lda	(z_drecy),y     ;the y offset
	clc
	adc	z_spriy         ;add to sprite y loc
	cmp	#224           ;is it below screen?
	bcc	.croamy        ;if not then store it
	cmp	v_spriedge      ;is it less than neg edge above screen?
	bcc	.croamnext     ;if not then do next object
.croamy
	sta	OBJECT+1,x     ;put y in oam shadow
	lda	(z_drecnum),y    ;the object number
	clc
	adc	v_spriteoff     ;offset of this sprite in vram table
	sta	OBJECT+2,x

	lda	>_croamdat,x	;oam size/highbit mask for this offset
	sta	z_temp4	;save it

	lda	>_croamdat+2,x	;oam loc for this offset
	tax

	lda	z_temp0         ;x sign flag
	bmi	.croamxneg
	lda	z_temp4         ;get the mask
	and	OBJECT+$200,x  ;mask the word with the bit in it
	sta	OBJECT+$200,x  ;store it back
.croamxneg  
	lda	(z_drecdim),y   ;dimension of object
	cmp	v_spritedim     ;set to larger size dim
	bne	.croamcont     ;if not equal then small size so skip
	rol	z_temp4         ;carry is set for rol
	lda	z_temp4         ;get it
	eor	#$FFFF         ;reverse it
	ora	OBJECT+$200,x  ;set size bit with it
	sta	OBJECT+$200,x  ;store size bit
.croamcont
	lda	z_oamcount      ;increment oamcount to reflect addition
	clc
	adc	#4             ;four bytes per entry
	sta	z_oamcount
	cmp	#$200          ;end of oam? (last slot skipped for speed above)
	beq	.croamdone     ;yes then exit
.croamnext  
	iny                  ;otherwise, get next object in sprite
	iny                  ;otherwise, get next object in sprite
	dec	z_sprisize      ;check for next object
	beq	.croaminc      ;if not more skip jump
	jmp	.croamloop     ;more so jump back
.croaminc   
	ldx	z_ztemp        ;done so get count
	inx                  ;increment for next attr entry
	inx
	jmp	.croam0        ;loop back to beginning
.croamdone  
	plb
	rtl

.croamflip  
	cmp	#$4000
	beq	.hcroam
	cmp	#$8000
	bne	.bcroamlink
	brl	.vcroam
.bcroamlink 
	brl	.bcroam

.hcroam
	lda	v_spriteoff
	and	#$3fff
	sta	v_spriteoff
	lda	(z_dreccount),y	; number of objects in sprite
	sta	z_sprisize
	lda	(z_drecframe),y	; frame # -- offset into other tables
	tay		; ...the new indirect index
.hcroamloop
	lda	(z_drecdim),y	; dimension of object
	sta	z_temp2
	lda	#1	; amount of object that must show 
	sec
	sbc	z_temp2	; dimension of object
	sta	v_spriedge	; negative edge for display
	ldx	z_oamcount	; index for next object in oam
	lda	(z_drecx),y	; the x offset for this sub object
	eor	#$ffff	; negate
	inc
	sty	z_temp3
	ldy	z_temp2
	cpy	#16            ;small size
	ldy	z_temp3
	bcs	.hbigdim
	adc	#8            ;16x16 offset compared with 32x32 flipped
	sec
.hbigdim    
	sbc	#16
	clc
	adc	z_sprix         ;add to sprite x location
	sta	OBJECT,x       ;put x location in oam shadow
	cmp	#256           ; is it greater than right edge?
	bcc	.hcroamx        ;if not then branch to store it
	cmp	v_spriedge      ;is it less than negative edge?
	bcc	.hcroamnext     ;if not then do next object
	lda	#$FFFF         ;flag negative x
	bmi	.hcroamx2
.hcroamx     
	lda	#0             ;flag positive x
.hcroamx2
	sta	z_temp0         ;store flag
	lda	(z_drecy),y     ;the y offset
	clc
	adc	z_spriy         ;add to sprite y loc
	cmp	#224           ;is it below screen?
	bcc	.hcroamy        ;if not then store it
	cmp	v_spriedge      ;is it less than neg edge above screen?
	bcc	.hcroamnext     ;if not then do next object
.hcroamy
	sta	OBJECT+1,x     ;put y in oam shadow
	lda	v_spriteoff
	clc
	adc	(z_drecnum),y    ;the object number
	eor	#$4000
	sta	OBJECT+2,x

	lda   >_croamdat,x    ;oam size/highbit mask for this offset
	sta   z_temp4         ;save it

	lda	>_croamdat+2,x
	tax

	lda   z_temp0         ;x sign flag
	bmi   .hcroamxneg
	lda   z_temp4         ;get the mask
	and   OBJECT+$200,x  ;mask the word with the bit in it
	sta   OBJECT+$200,x  ;store it back
.hcroamxneg  
	lda	(z_drecdim),y   ;dimension of object
	cmp	v_spritedim     ;set to larger size dim
	bne	.hcroamcont     ;if not equal then small size so skip
	rol	z_temp4         ;carry is set for rol
	lda	z_temp4         ;get it
	eor	#$FFFF         ;reverse it
	ora	OBJECT+$200,x  ;set size bit with it
	sta	OBJECT+$200,x  ;store size bit
.hcroamcont
	lda	z_oamcount      ;increment oamcount to reflect addition
	clc
	adc	#4             ;four bytes per entry
	sta	z_oamcount
	cmp	#$200          ;end of oam? (last slot skipped for speed above)
	beq	.hcroamdone     ;yes then exit
.hcroamnext  
	iny                  ;otherwise, get next object in sprite
	iny                  ;otherwise, get next object in sprite
	dec	z_sprisize      ;check for next object
	beq	.hcroaminc      ;if not more skip jump
	jmp	.hcroamloop     ;more so jump back
.hcroaminc   
	ldx	z_ztemp                  ;done so get count
	inx                  ;increment for next attr entry
	inx
	jmp	.croam0        ;loop back to beginning
.hcroamdone  
	plb
	rtl

.vcroam
	lda	v_spriteoff
	and	#$3fff
	sta	v_spriteoff
	lda	(z_dreccount),y   ;number of objects in sprite
	sta	z_sprisize
	lda	(z_drecframe),y  ;frame # -- offset into other tables
	tay                   ;           the new indirect index
.vcroamloop
	lda	(z_drecdim),y   ;dimension of object
	sta	z_temp2
	lda	#1             ;amount of object that must show 
	sec
	sbc	z_temp2         ;dimension of object
	sta	v_spriedge      ;negative edge for display
	ldx	z_oamcount      ;index for next object in oam
	sty	z_temp3
	lda	(z_drecx),y     ;the x offset for this sub object
	clc
	adc	z_sprix         ;add to sprite x location
	sta	OBJECT,x       ;put x location in oam shadow
	cmp	#256           ; is it greater than right edge?
	bcc	.vcroamx        ;if not then branch to store it
	cmp	v_spriedge      ;is it less than negative edge?
	bcs	.vcroamx0
	brl	.vcroamnext     ;if not then do next object
.vcroamx0
	lda	#$FFFF         ;flag negative x
	bmi	.vcroamx2
.vcroamx     
	lda	#0             ;flag positive x
.vcroamx2
	sta	z_temp0         ;store flag
	lda	(z_drecy),y     ;the y offset
	eor	#$ffff         ;negate
	inc
	ldy	z_temp2
	cpy	#16            ;small size
	ldy	z_temp3
	bcs	.vbigdim
	adc	#8            ;16x16 offset compared with 32x32 flipped
	sec
.vbigdim
	sbc	#16
	clc
	adc	z_spriy         ;add to sprite y loc
	cmp	#224           ;is it below screen?
	bcc	.vcroamy        ;if not then store it
	cmp	v_spriedge      ;is it less than neg edge above screen?
	bcc	.vcroamnext    ;if not then do next object
.vcroamy
	sta	OBJECT+1,x     ;put y in oam shadow
	lda   v_spriteoff     ;offset of this sprite in vram table
	clc
	adc	(z_drecnum),y    ;the object number
	eor	#$8000
	sta	OBJECT+2,x

	lda	>_croamdat,x    ;oam size/highbit mask for this offset
	sta	z_temp4         ;save it

	lda	>_croamdat+2,x
	tax

	lda	z_temp0         ;x sign flag
	bmi	.vcroamxneg
	lda	z_temp4         ;get the mask
	and	OBJECT+$200,x  ;mask the word with the bit in it
	sta	OBJECT+$200,x  ;store it back
.vcroamxneg  
	lda	(z_drecdim),y   ;dimension of object
	cmp	v_spritedim     ;set to larger size dim
	bne	.vcroamcont     ;if not equal then small size so skip
	rol	z_temp4         ;carry is set for rol
	lda	z_temp4         ;get it
	eor	#$FFFF         ;reverse it
	ora	OBJECT+$200,x  ;set size bit with it
	sta	OBJECT+$200,x  ;store size bit
.vcroamcont
	lda	z_oamcount      ;increment oamcount to reflect addition
	clc
	adc	#4             ;four bytes per entry
	sta	z_oamcount
	cmp	#$200          ;end of oam? (last slot skipped for speed above)
	beq	.vcroamdone     ;yes then exit
.vcroamnext 
	iny
	iny                  ;otherwise, get next object in sprite
	dec	z_sprisize      ;check for next object
	beq	.vcroaminc      ;if not more skip jump
	jmp	.vcroamloop     ;more so jump back
.vcroaminc   
	LAI
	ldx	z_ztemp                  ;done so get count
	inx                  ;increment for next attr entry
	inx
	jmp	.croam0        ;loop back to beginning
.vcroamdone  
	plb
	rtl


.bcroam
	lda	v_spriteoff
	and	#$3fff
	sta	v_spriteoff
	lda	(z_dreccount),y   ;number of objects in sprite
	sta	z_sprisize
	lda	(z_drecframe),y  ;frame # -- offset into other tables
	tay                   ;           the new indirect index
.bcroamloop
	lda	(z_drecdim),y   ;dimension of object
	sta	z_temp2
	lda	#1             ;amount of object that must show 
	sec
	sbc	z_temp2         ;dimension of object
	sta	v_spriedge      ;negative edge for display
	ldx	z_oamcount      ;index for next object in oam
	sty	z_temp3
	lda	(z_drecx),y     ;the x offset for this sub object
	eor	#$ffff         ;negate
	inc
	ldy	z_temp2
	cpy	#16            ;small size
	ldy	z_temp3
	bcs	.bigdimx
	adc	#8            ;16x16 offset compared with 32x32 flipped
	sec
.bigdimx    
	sbc	#16
	clc
	adc	z_sprix         ;add to sprite x location
	sta	OBJECT,x       ;put x location in oam shadow
	cmp	#256           ; is it greater than right edge?
	bcc	.bcroamx        ;if not then branch to store it
	cmp	v_spriedge      ;is it less than negative edge?
	bcs	.bcroamx0
	brl	.bcroamnext     ;if not then do next object
.bcroamx0
	lda	#$FFFF         ;flag negative x
	bmi	.bcroamx2
.bcroamx     
	lda	#0             ;flag positive x
.bcroamx2
	sta	z_temp0         ;store flag
	lda	(z_drecy),y     ;the y offset
	eor	#$ffff         ;negate
	inc
	ldy	z_temp2
	cpy	#16            ;small size
	ldy	z_temp3
	bcs	.bigdimy
	adc	#8            ;16x16 offset compared with 32x32 flipped
	sec
.bigdimy    
	sbc	#16
	clc
	adc	z_spriy         ;add to sprite y loc
	cmp	#224           ;is it below screen?
	bcc	.bcroamy        ;if not then store it
	cmp	v_spriedge      ;is it less than neg edge above screen?
	bcc	.bcroamnext     ;if not then do next object
.bcroamy
	sta	OBJECT+1,x     ;put y in oam shadow
	lda	v_spriteoff     ;offset of this sprite in vram table
	clc
	adc	(z_drecnum),y    ;the object number
	eor	#$c000
	sta	OBJECT+2,x

	lda	>_croamdat,x    ;oam size/highbit mask for this offset
	sta	z_temp4         ;save it

	lda	>_croamdat+2,x
	tax

	lda	z_temp0         ;x sign flag
	bmi	.bcroamxneg
	lda	z_temp4         ;get the mask
	and	OBJECT+$200,x  ;mask the word with the bit in it
	sta	OBJECT+$200,x  ;store it back
.bcroamxneg  
	lda	(z_drecdim),y   ;dimension of object
	cmp	v_spritedim     ;set to larger size dim
	bne	.bcroamcont     ;if not equal then small size so skip
	rol	z_temp4         ;carry is set for rol
	lda	z_temp4         ;get it
	eor	#$FFFF         ;reverse it
	ora	OBJECT+$200,x  ;set size bit with it
	sta	OBJECT+$200,x  ;store size bit
.bcroamcont
	lda	z_oamcount      ;increment oamcount to reflect addition
	clc
	adc	#4             ;four bytes per entry
	sta	z_oamcount
	cmp	#$200          ;end of oam? (last slot skipped for speed above)
	beq	.bcroamdone     ;yes then exit
.bcroamnext  
	iny                  ;otherwise, get next object in sprite
	iny                  ;otherwise, get next object in sprite
	dec	z_sprisize      ;check for next object
	beq	.bcroaminc      ;if not more skip jump
	jmp	.bcroamloop     ;more so jump back
.bcroaminc   
	ldx	z_ztemp                  ;done so get count
	inx 	                ;increment for next attr entry
	inx
	jmp	.croam0        ;loop back to beginning
.bcroamdone  
	plb
	rtl


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;a=vram addr
;y=frame * 2 (word index)
Sendframeroxy:
	phb
	ldx	v_xfercount
	sta	v_xferdest,x
	clc
	adc	#$100	  
	sta	v_xferdest+2,x

	sty	z_temp6	;frame

	lda	z_dreccount      	;bank
	SA
	pha
	LA
	plb
	sta	v_xferbank,x
	sta	v_xferbank+2,x

	ldy	#16
	lda	(z_spridrec),y	;len2 array
	sta	z_drecy
	ldy	#14
	lda	(z_spridrec),y	;len1 array
	sta	z_drecx
	ldy	#12
	lda	(z_spridrec),y	;loc array
	sta	z_spridrec

	ldy	z_temp6
	lda	(z_spridrec),y	;loc for this frame
	sta	v_xferloc,x	;source1
	lda	(z_drecx),y	;len1 for this frame
	sta	v_xferlen,x

	inx
	inx

	lda	(z_drecy),y	;len2 for this frame
	beq	.end
	sta	v_xferlen,x	
	lda	(z_spridrec),y	;loc for this frame
	clc
	adc	(z_drecx),y	;loc+len1=loc2 for this frame
	sta	v_xferloc,x
	inx
	inx
.end
	stx	v_xfercount
	plb
	rtl


;send frame for proxy

Sendframe:
	phb

	ldx	v_xfercount
	
	sta	z_temp7	; VRAM address (dest0)
	sty	z_temp6	; Frame

	lda	z_dreccount	; Bank
	SA
	pha
	LA
	plb
	
	ldy	#14
	lda	(z_spridrec),y	;len pointer
	sta	z_drecx
	ldy	#12
	lda	(z_spridrec),y	;loc pointer
	sta	z_spridrec

	ldy	z_temp6	;frame number

	lda	(z_spridrec),y	;loc for this frame
	sta	z_spridrec

	lda	(z_drecx),y
	sta	z_drecy	;len array for this frame

	iny
	iny
	lda	(z_drecx),y	;next len array
	sta	z_drecx	;save over len pointer

	stz	z_temp8
	ldy	#0
.loop
	lda	z_temp7	;dest vram address
	clc
	adc	z_temp8
	sta	v_xferdest,x

	lda	z_dreccount	;source bank
	sta	v_xferbank,x

	lda	z_spridrec	;source record loc
	sta	v_xferloc,x
	
	lda	(z_drecy),y	;len from array
	sta	v_xferlen,x	

	clc
	adc	z_spridrec
	sta	z_spridrec	;udate source addr with current len
			;for next loop

	lda	v_xferlen,x	;get curr len
	lsr
	clc
	adc	z_temp8	;old vram dest
	sta	z_temp8	;save as new dest

	and	#$ff	;check for partial line
	beq	.addrokay	;if not then okay
	lda	z_temp8
	clc		;otherwise add one more line
	adc	#$100
	and	#$ff00
	sta	z_temp8

.addrokay
	inx
	inx

	inc	z_drecy
	inc	z_drecy
	lda	z_drecy
	cmp	z_drecx
	bcc	.loop
.end
	stx	v_xfercount
	plb
	rtl

Senddata:
	SI
	ldx	#<VMDATAL
	stx	DMA0DEST	; write to vram data register
	ldx	#$01
	stx	DMA0INC	; write words
	ldx	#$80
	stx	VMAINC	; set inc on $2119 (write words)
	ldx	v_xfercount
.loop
	dex
	dex
	bmi	.end

	lda	v_xferloc,x
	sta	DMA0A1L	; set source address
	lda	v_xferdest,x
	sta	VMADDL 	; address to write to
	lda	v_xferlen,x
	sta	DMA0NUML	; set dma size
	ldy	v_xferbank,x	; get bank from stack
	sty	DMA0A1B	; set source bank
	ldy	#$01
	sty	MDMAEN	; trigger dma
	bra	.loop
.end
	LI
	stz	v_xfercount
	rtl


*****************************************************************************
*
*
*****************************************************************************

Clearoam:
	LAI

	stz	z_oamcount

	lda	#$5555	; sets high bit to off screen
	ldx	#$21E	; length of oam
.loop:
	sta	OBJECT,x	; object is oam shadow

	dex
	dex

	bpl	.loop

	rtl


*****************************************************************************
*
*
*****************************************************************************

Resetattr:
	LAI

	stz	z_attrcount

	ldx	#$fe
.clrloop
	stz	ATTROFF,x

	dex
	dex

	bpl	.clrloop

	rtl


