*****************************************************************************
*
* TRANSART.ASM
*
* The 1st  7 banks are 32h, 33h, 34h, 35h, 36h, 37h, 38h
*	       50   51   52   53   54   55   56
*                        
*
*****************************************************************************

	.output	'dasm'

	.list	'transart.lst'

	.asym


		.org	$328000

liftjan1csm
		.incl	'eondata\liftjan1.csm'
clearingccs
		.incl	'eondata\clearing.ccs'
shot33csm
		.incl	'eondata\3shot3.csm'
		.incl	'eondata\title1.pal'

		.org	$338000

liftjan2csm
		.incl	'eondata\liftjan2.csm'
tempwinccs
		.incl	'eondata\tempwin.ccs'
closeup3csm
		.incl	'eondata\closeup3.csm'
gameintro1scr
		.incl	'eondata\intro1.csm'

		.org	$348000

password.ccs
		.incl	'eondata\password.ccs'
stirccs
		.incl	'eondata\stir.ccs'
title1ccs
		.incl	'eondata\title1.ccs'
crouch1csm
		.incl	'eondata\crouch1.csm'
		.incl	'eondata\sunset3.pal'
		.incl	'eondata\closeup3.pal'

		.org	$358000

shot31ccs
		.incl	'eondata\3shot1.ccs'
titlemancsm
		.incl	'eondata\titlemr.csm'
sunset1ccs
		.incl	'eondata\sunset1.ccs'
closeupccs
		.incl	'eondata\closeup.ccs'
		.incl	'eondata\3shot3.pal'
liftjanseq
		.incl	'eondata\liftjan.seq'
titlemanpal
		.incl	'eondata\titleman.pal'
tempwinpal
		.incl	'eondata\tempwin.pal'
oldguypal
		.incl	'eondata\oldguy.pal'

		.org	$368000

cage1ccs
		.incl	'eondata\cage1.ccs'
sunset2ccs
		.incl	'eondata\sunset2.ccs'
crouch1ccs
		.incl	'eondata\crouch1.ccs'
		.incl	'eondata\meteor.ssm'
options.ccs
		.incl	'eondata\cmpressd\options.ccs'
title1csm
		.incl	'eondata\title1.csm'
		.incl	'eondata\oldguy.ssm'
closeup3ccs
		.incl	'eondata\closeup3.ccs'
shot33ccs
		.incl	'eondata\3shot3.ccs'
		.incl	'eondata\meteor.pal'
liftjanpal
		.incl	'eondata\liftjan.pal'
		.incl	'eondata\font8X8.pal'

		.org	$378000

gametekchr
		.incl	'eondata\gtscrns.ccs'
options.clm
		.incl	'eondata\cmpressed\options.csm'
password.clm
		.incl	'eondata\password.csm'
tempwincsm
		.incl	'eondata\tempwin.csm'
clearingcsm
		.incl	'eondata\clearing.csm'
stircsm
		.incl	'eondata\stir.csm'
sunset2csm			
		.incl	'eondata\sunset2.csm'
shot31csm
		.incl	'eondata\3shot1.csm'
sunset1csm
		.incl	'eondata\sunset1.csm'
closeupcsm
		.incl	'eondata\closeup.csm'
gametekscr
		.incl	'eondata\gtscrns.csm'
sunset3csm
		.incl	'eondata\sunset3.csm'
cage1csm
		.incl	'eondata\cage1.csm'
font8x8ccs
		.incl	'eondata\font8X8.ccs'
sunset3ccs
		.incl	'eondata\sunset3.ccs'
gameintro1chr
		.incl	'eondata\intro1.ccs'
		.incl	'eondata\sunset1.pal'
		.incl	'eondata\stir.pal'
password.pal
		.incl	'eondata\password.pal'
;		.incl	'eondata\passwrd1.pal'
options.pal
		.incl	'eondata\options\options.pal'
gameintro1pal
		.incl	'eondata\intro1.pal'
gametekpal
		.incl	'eondata\gtscrns.pal'
		.incl	'eondata\crouch1.pal'
		.incl	'eondata\closeup.pal'
		.incl	'eondata\clearing.pal'
		.incl	'eondata\cage1.pal'
		.incl	'eondata\3shot1.pal'

licensebychr
		.incl	'eondata\license.ccs'
licensebyscr
		.incl	'eondata\license.csm'
licensebypal
		.incl	'eondata\license.pal'


; Sprite for Reef Level
		.incl	'nrocdata\reefair.ssm'


		.org	$388000

		.incl	'nrocdata\title01.ssm'
		.incl	'nrocdata\title02.ssm'
		.incl	'nrocdata\title03.ssm'
		.incl	'nrocdata\title04.ssm'
		.incl	'nrocdata\title05.ssm'
		.incl	'nrocdata\title06.ssm'
		.incl	'nrocdata\title07.ssm'
		.incl	'nrocdata\title08.ssm'
		.incl	'nrocdata\title09.ssm'
		.incl	'nrocdata\title10.ssm'
		.incl	'nrocdata\title11.ssm'
		.incl	'nrocdata\title12.ssm'
		.incl	'nrocdata\title13.ssm'
		.incl	'nrocdata\title14.ssm'
		.incl	'nrocdata\title15.ssm'
		.incl	'nrocdata\title16.ssm'
		.incl	'nrocdata\title17.ssm'
		.incl	'nrocdata\title18.ssm'

		.incl	'nrocdata\title01.pal'

		.incl	'nrocdata\allpass.ssm'

		.incl	'nrocdata\pass01.pal'



		.org	$398000
gameoverchr2
		.incl	'endgame\gmovrbg2.ccs'
gameoverscr2
		.incl	'endgame\gmovrbg2.csm'
gameoverpal
		.incl	'endgame\gmovrbg2.pal'

gameoverchr
		.incl	'endgame\gmovrbg1.ccs'
gameoverscr
		.incl	'endgame\gmovrbg1.csm'

passbackchr
		.incl	'eondata\passback.ccs'
passbackscr
		.incl	'eondata\passback.csm'
