************************************************************************
*
* VARS.ASM
*
************************************************************************
*
* Music Driver related

ModTabSize	.ds	$02	; Number of entries in the module table
ModTabPtr	.ds	$02	; Save Y index for current module table entry
MODULE	.ds	$02	; (needed only if load_Module is used)
SONGNUMBER	.ds	$02	; (needed only if load_Song is used)
EFFECTNUMBER	.ds	$02	; (needed only if load_Effect is used)
BON	.ds	$02	; blasting on/off (not available with this version)

*
************************************************************************
*

v_totalsongs  	.ds	$02
v_totaleffects	.ds	$02

v_curmusmodule	.ds	$02
v_cursong	.ds	$02
v_cureffect	.ds	$02

v_codedelay	.ds	$02
v_passcode	.ds	$02
v_givepass	.ds	$02
v_inoptions	.ds	$02

v_insand	.ds	$02
v_sandlytog	.ds	$02

v_priestdead	.ds	$02
v_holdnum	.ds	$02
v_timefall	.ds	$02
v_leavehold	.ds	$02
v_falling	.ds	$02

v_mistdly	.ds	$02
v_gmovrdly	.ds	$02
v_bosslevel	.ds	$02

v_lrmovdly	.ds	$02

v_togstatupdate	.ds	$02

v_xpostate	.ds	$02
v_xspeed	.ds	$02

v_donedark	.ds	$02

v_bossbaron	.ds	$02

v_idle4pkdly	.ds	$02

v_addbossdamage	.ds	$02
v_endgameyes	.ds	$02

v_priestindex	.ds	$02
v_noplayxmov	.ds	$02
v_bighitos	.ds	$02

v_bighitxadj	.ds	$02
v_bighityadj	.ds	$02

v_apebossdead	.ds	$02
v_felldie	.ds	$02

v_bary	.ds	$02

**************************************** 
* 
* Mode 7 Vars

;
;_lense	.ds	$02	; HIGH BYTE MAGNIFICATION
;_magnify	.ds	$02	; LOW BYTE MAGNIFICATION
;
;_acalc	.ds	$02 	; A Param (MODE 7); Magnification
;_bcalc	.ds	$02 	; B Param (MODE 7); Angle Values
;_ccalc	.ds	$02 	; C Param (MODE 7); Angle Values
;_dcalc	.ds	$02 	; D Param (MODE 7); Magnification
;_angle	.ds	$02 	; Rotation angle of screen
;_reduce	.ds	$02 	; Reduction calculation for angles
;_cos	.ds	$02 	; Cosine Value
;_sin	.ds	$02 	; Sine Value 
; 
;
**************************************** 
* 

v_curtzanpal	.ds	$02	; Holds current pal for Tarzan
v_pause	.ds	$02
v_pauseos	.ds	$02
v_resettbos	.ds	$02

v_JOYPAD2ENABLE	.ds	$02
v_DebugMode	.ds	$02	; Main Debug Mode indicator
v_MapGUI	.ds	$02
v_debugswitch1	.ds	$02	; Subswitch1 :
v_dboneshot	.ds	$02
v_plotcbox	.ds	$02

v_eolhit	.ds	$02	; Tarzan intersects EOL icon

v_waveroll	.ds	$02

**************************************** 
* 
* Chek4flr vars

v_tileindex	.ds     $02
v_tilenum	.ds     $02
v_sigtiles	.ds     $02

**************************************** 
* 
* Color Cycling Vars

v_cyclepass	.ds	$02

v_cycledly1	.ds	$02
v_cycledly2	.ds	$02
v_cycledly3	.ds	$02
v_cycledly4	.ds	$02
v_cycledly5	.ds	$02

v_colorcel1	.ds	$02
v_colorcel2	.ds	$02
v_colorcel3	.ds	$02
v_colorcel4	.ds	$02
v_colorcel5	.ds	$02


v_cyclface	.ds	$02

v_demostate	.ds	$02	; Current state # of demo
v_demoplay	.ds	$02	; BOOL: true means playing back data from DemoPtr,DemoBank
v_demorecord	.ds	$02	; BOOL: true means storing demo info to $7f0000
v_demoptr	.ds	$02	; current demo data Input/Output point
v_demobank	.ds	$02	; bank of current play demo data

v_demodelay	.ds	$02
v_lastdemo	.ds	$02

v_killdemorec	.ds	$02
v_demoreturn	.ds	$02

**************************************** 
* 
* Multitap Vars

;_mt5status	.ds	$01
;_mt5reg0l	.ds	$01
;_mt5reg0h	.ds	$01
;_mt5reg1l	.ds	$01
;_mt5reg1h	.ds	$01

v_repeat	.ds	$02



;counters for button debounce
v_bcount 	.ds	$02
v_ycount	.ds	$02
v_selectcount	.ds	$02
v_startcount	.ds	$02
v_upcount	.ds	$02
v_downcount	.ds	$02
v_leftcount	.ds	$02
v_rightcount	.ds	$02
v_acount	.ds	$02
v_xcount	.ds	$02
v_lcount	.ds	$02
v_rcount	.ds	$02

v_bcount2 	.ds	$02
v_ycount2	.ds	$02
v_selectcount2	.ds	$02
v_startcount2	.ds	$02
v_upcount2	.ds	$02
v_downcount2	.ds	$02
v_leftcount2	.ds	$02
v_rightcount2	.ds	$02
v_acount2	.ds	$02
v_xcount2	.ds	$02
v_lcount2	.ds	$02
v_rcount2	.ds	$02


; Used only for multitap controller

v_bcount3 	.ds	$02
;_ycount3	.ds	$02
;_selectcount3	.ds	$02
;_startcount3	.ds	$02
;_upcount3	.ds	$02
;_downcount3	.ds	$02
;_leftcount3	.ds	$02
;_rightcount3	.ds	$02
;_acount3	.ds	$02
;_xcount3	.ds	$02
;_lcount3	.ds	$02
;_rcount3	.ds	$02
;
v_bcount4 	.ds	$02
;_ycount4	.ds	$02
;_selectcount4	.ds	$02
;_startcount4	.ds	$02
;_upcount4	.ds	$02
;_downcount4	.ds	$02
;_leftcount4	.ds	$02
;_rightcount4	.ds	$02
;_acount4	.ds	$02
;_xcount4	.ds	$02
;_lcount4	.ds	$02
;_rcount4	.ds	$02
;
v_bcount5 	.ds	$02
;_ycount5	.ds	$02
;_selectcount5	.ds	$02
;_startcount5	.ds	$02
;_upcount5	.ds	$02
;_downcount5	.ds	$02
;_leftcount5	.ds	$02
;_rightcount5	.ds	$02
;_acount5	.ds	$02
;_xcount5	.ds	$02
;_lcount5	.ds	$02
;_rcount5	.ds	$02


***************************
* Scroll Vars

v_storeaddr1	.ds	$02
v_storeaddr2	.ds	$02
v_storeaddr3	.ds	$02

v_hoff1max  	.ds	$02
v_hoff1min  	.ds	$02
v_voff1max  	.ds	$02
v_voff1min  	.ds	$02

v_maxx	.ds	$02
v_minx	.ds	$02

v_fallmax	.ds	$02

***************************
* Sprite Vars

v_animcount	.ds	$02

v_spriedge	.ds	$02
v_spriteoff	.ds	$02
v_spritedim	.ds	$02
v_codefailed	.ds	$02

v_restart	.ds	$02
v_bakup	.ds	$02

v_disbgscroll	.ds	$02
v_addscroll	.ds	$02
v_sudebounce	.ds	$02
v_sky3dly	.ds	$02

v_1upcount	.ds	$02
v_1upseq	.ds	$02
v_1upflip	.ds	$02

v_coinstep	.ds	$02
v_coinseq	.ds	$02
v_coinflip	.ds	$02

v_coincur	.ds	$02
v_coinlast	.ds	$02

v_tzpaltogl	.ds	$02
v_pause2	.ds	$02
v_shimertimer	.ds	$02

v_xyoneshot	.ds	$02

v_daggerx	.ds	$02
v_daggery	.ds	$02
v_daggerflip	.ds	$02
v_daggerdone	.ds	$02

v_frmdsp	.ds	$02
v_frmdsposhot	.ds	$02

v_passcoderr	.ds	$02

v_damageflag	.ds	$02

v_intcompletion	.ds	$02	; Alternate level completion
v_objpriority	.ds	$02

v_healthframe	.ds	$02
v_xynumframe	.ds	$10

v_stroke	.ds	$02
v_stride	.ds	$02	; Basic stride speed
v_stridey	.ds	$02	; Basic stride speed in y direction
v_velocity	.ds	$02	; Velocity      (x/y component)
v_gravity	.ds	$02	; Gravity       (y component)
v_current	.ds	$02	; River current (x component)

v_whichjmp	.ds	$02

v_invinceff	.ds	$02

v_lives	.ds	$02
v_lastlives	.ds	$02
v_endlevel	.ds	$02

v_bobwater	.ds	$02

_walls	.ds	$02
v_tilestat	.ds	$02	;holds current tile types byte
;_charloc	.ds	$04	;holds current floor location in big map
_bgenable	.ds	$02

v_vin1sot	.ds	$02	; Woosh sound on vine frame #4

v_totalpoints	.ds	$02
v_levelpoints	.ds	$02
v_extrapoints	.ds	$02
v_health	.ds	$02
v_lasthealth	.ds	$02
v_markfall	.ds	$02

v_bossactive	.ds	$02
v_bosshit	.ds	$02
v_bossinvince  	.ds	$02
v_bossoldhealth	.ds	$02
v_bosshealth   	.ds	$02
v_bossdead	.ds	$02
v_savbosshealth	.ds	$02

v_flameaddr	.ds	$02
v_flamebank	.ds	$02
v_flamedest	.ds	$02
v_flametype	.ds	$02

v_lostlife	.ds	$02
v_levelfail	.ds	$02

v_charbuffer	.ds	$32
v_return	.ds	$02
v_caller	.ds	$02


MAXFOE	.equ	35*2
v_foetype	.ds	MAXFOE
v_foeframe	.ds	MAXFOE
v_foeactframe	.ds	MAXFOE
v_foeoff	.ds	MAXFOE
v_foeactoff	.ds	MAXFOE
v_foevelx	.ds	MAXFOE
v_foevely	.ds	MAXFOE
v_foedelay	.ds	MAXFOE
v_foex	.ds	MAXFOE
v_foey	.ds	MAXFOE
v_foehit	.ds	MAXFOE
v_foepos1	.ds	MAXFOE
v_foepos2	.ds	MAXFOE
v_foeaux1	.ds	MAXFOE
v_foeaux2	.ds	MAXFOE
v_foeaux3	.ds	MAXFOE
v_foeai	.ds	MAXFOE
v_foeplot	.ds	MAXFOE
v_foemisc1	.ds	MAXFOE
v_foemisc2	.ds	MAXFOE
v_foedma	.ds	MAXFOE
v_foemode	.ds	MAXFOE
v_foepriority	.ds	MAXFOE

v_foeleft	.ds	$02
v_foerite	.ds	$02
v_foetop	.ds	$02
v_foebot	.ds	$02

v_rightedge	.ds	$02

v_water	.ds	$24
v_hitmonkey	.ds	$02

v_pitopen	.ds	$02
v_maxxfercnt	.ds	$02

v_shakescreen	.ds	$02
v_bigfoehit	.ds	$02
v_slapos	.ds	$02


MAXHOLE	.equ	20
v_nexthole	.ds	$02
v_holex	.ds	MAXHOLE
v_holey	.ds	MAXHOLE

; --------------------------------------
v_foekillfrm	.ds	$02	; If 1 then then current frame kills
v_foeknife	.ds	$02
v_knifeactive	.ds	$02

v_dartactive	.ds	$02	; If 1 then dart is in the air
v_dartleft	.ds	$02
v_dartrite	.ds	$02
v_darttop	.ds	$02
v_dartbot	.ds	$02
v_dartx	.ds	$02
v_darty	.ds	$02
v_dartstep	.ds	$02
v_dartgrav	.ds	$02
v_dartdir	.ds	$02
v_darthit	.ds	$02
v_numdart	.ds	$04
v_lastnumdart	.ds	$02
v_dartdy	.ds	$02

v_bobdelay	.ds	$02

***************************
*
* Players vars

v_playertype	.ds	$02	;   0 - playertype MUST stay first...
v_playerx	.ds	$02	;   .
v_playery	.ds	$02	;   .
v_playeroldx	.ds	$02	;   .
v_playeroldy	.ds	$02	;   v

v_playerxglob	.ds	$02	
v_playeryglob	.ds	$02
v_playergloboff	.ds	$02
v_playinvince	.ds	$02
v_playerflip	.ds	$02

v_playerseq	.ds	$02
v_playerframe	.ds	$02
v_playerseqlog	.ds	$02
v_playerdelay	.ds	$02
v_playeroff	.ds	$02

v_playerdrec	.ds	$02
v_playernewtype	.ds	$02
v_playeroveride	.ds	$02
v_playerbank	.ds	$02
v_playerdir	.ds	$02

v_playertop	.ds	$02
v_playerbot	.ds	$02
v_playerrite	.ds	$02
v_playerleft	.ds	$02
v_playercentrx	.ds	$02

v_playercentry	.ds	$02
v_playeroffx1	.ds	$02
v_playeroffy1	.ds	$02
v_playerAI	.ds	$02
v_savpAI	.ds	$02

v_playchngdir	.ds	$02
v_donenifsfx	.ds	$02	; Knife SFX one-shot
v_donedrtsfx	.ds	$02	; Dart  SFX one-shot
v_doneroar	.ds	$02	; Roar  SFX one-shot
v_oldplytype	.ds	$02

v_tzanslot	.ds	$02

v_weaponsel	.ds	$02
v_lastweap	.ds	$02

v_plyrxsmpl	.ds	$02

***************************
* Vine Vars

v_vinedat	.ds	$02
v_curvine	.ds	$02
v_vinetype	.ds	$0A	; Room for 5 vines
v_vinex	.ds	$0A
v_viney	.ds	$0A
v_vinedir	.ds	$0A
v_vinerst	.ds	$0A
v_vinedirparm	.ds	$02


; Misc. animations, stats, items, etc

v_items	.ds	($30*8)+2	; 48 items - ID,X,Y,status

v_buttonpress	.ds	$02

v_idlecount	.ds	$02	; counter to idle animations
v_fastidle	.ds	$02


***************************
*
*

v_bg1vofs	.ds	$02
v_bg2vofs	.ds	$02
v_bg3vofs	.ds	$02

v_bg1hofs	.ds	$02
v_bg2hofs	.ds	$02
v_bg3hofs	.ds	$02

v_maxscroll	.ds	$02
v_contrlmap	.ds	$02	; Holds selected controller map

_dxmid	.ds	$02
_dymid	.ds	$02
v_savxmid	.ds	$02
v_savymid	.ds	$02

_optselect	.ds	$02


v_xfercount	.ds	$02
v_xferloc 	.ds	$20
v_xferbank	.ds	$20
v_xferlen	.ds	$20
v_xferdest	.ds	$20


**************************************** 
* 
*  River HDMA
*
v_riveron	.ds	$02
v_dnrivpos	.ds	$02
v_dnrivoff	.ds	$10
v_dnrivhoff	.ds	$10
v_dnrivincval	.ds	$02
v_hdmatblptr	.ds	$02
v_dnrivtabl	.ds	$20

v_wavcount	.ds	$02

v_scratch	.ds	$20	; 32 bytes of scratch RAM for tmp vars
l_rivdmaend

eq_rivdmalen	.equ	l_rivdmaend - v_riveron

v_JOYPADB	.ds	$02

v_JUMPBUTTON
v_JOYPADY	.ds	$02

v_JOYPADSELECT	.ds	$02
v_JOYPADSTART	.ds	$02
v_JOYPADUP	.ds	$02
v_JOYPADDOWN	.ds	$02
v_JOYPADLEFT	.ds	$02
v_JOYPADRIGHT	.ds	$02
v_JOYPADA	.ds	$02
v_WEAPON	.ds	$02
v_JOYPADL	.ds	$02

v_RUNBUTTON
v_JOYPADR	.ds	$02

v_JOYPADABXY	.ds	$02
v_JOYARROWS	.ds	$02
v_JOYLEFTRIGHT	.ds	$02
v_JOYNOARROWS	.ds	$02
v_JOYPADLR	.ds	$02


ATTROFF	.ds	$80
ATTRX	.ds	$80
ATTRY	.ds	$80
ATTRDREC	.ds	$80
ATTRBANK	.ds	$80
ATTRFRAME	.ds	$80


OBJECT	.ds	$220
BG1BUFF	.ds	$80
BG2BUFF	.ds	$80
BG3BUFF	.ds	$80

PALETTE	.ds	$200
PALETTE2	.ds	$200


MAXAMB	.equ	14
v_ambienteff	.ds	MAXAMB
v_ambientrate	.ds	MAXAMB
v_ambientwait	.ds	MAXAMB



